#include <iostream>
#include <math.h>
#include <algorithm>
#define MAXN 128
using namespace std;

int n;
long long ans = 0, sum = 0;

struct point{
int x, y;
};

struct rect{
point a, b, c, d;
};

struct line{
int a, b, c;
};

rect r[MAXN];
bool w[5];


line makeline(point a, point b){
    line tmp;
    tmp.a = a.y-b.y;
    tmp.b = b.x-a.x;
    tmp.c = a.x*b.y-b.x*a.y;
    return tmp;
}

point prestochka(line a, line b){
    point cur;
    int tmp, tmp1, tmp2;
    tmp = a.a *b.b - a.b*b.a;
    if(tmp!=0){
        cur.x = (a.b*b.c-a.c*b.b)/tmp;
        cur.y = (a.c*b.a-a.a*b.c)/tmp;
    }else{
        cur.x = 0;
        cur.y = 0;
    }
    return cur;
}


int have_common(rect a1, rect a2){
    int in = 0;
    w[1]=0; w[2]=0; w[3]=0; w[4]=0;
if(a2.a.x >= a1.a.x && a2.a.x<=a1.c.x && a2.a.y>=a1.a.y && a2.a.y <= a1.d.y){
in++;
//A is in
w[1] = 1;
}

if(a2.b.x >= a1.a.x && a2.b.x<=a1.c.x && a2.b.y>=a1.a.y && a2.b.y <= a1.d.y){
in++;
//B is in
w[2] = 1;
}

if(a2.c.x >= a1.a.x && a2.c.x<=a1.c.x && a2.c.y>=a1.a.y && a2.c.y <= a1.d.y){
in++;
//C is in
w[3] = 1;
}

if(a2.d.x >= a1.a.x && a2.d.x<=a1.c.x && a2.d.y>=a1.a.y && a2.d.y <= a1.d.y){
in++;
//D is in
w[4] = 1;
}
return in;
}

long long calc_s(rect r){
long long s = 0;
s = abs(r.c.x-r.a.x)*abs(r.c.y-r.a.y);
return s;
}

void remove_s(int c, rect r1, rect r2, int touch){
    int rs;
if(c==0) return ;
if(c==1){
if(w[1]==1){
rs = abs(r1.c.x-r2.a.x)*abs(r1.c.y-r2.a.y);
ans -= rs;
//, !!! ^^
}
if(w[2]==1){
rs = abs(r1.d.x-r2.b.x)*abs(r1.d.y-r2.b.y);
ans -= rs;
}
if(w[3]==1){

rs = abs(r1.a.x-r2.c.x)*abs(r1.a.y-r2.c.y);
ans -= rs;
}
if(w[4]==1){
rs = abs(r1.b.x-r2.d.x)*abs(r1.b.y-r2.d.y);
ans -= rs;
}


}else if(c==2){
if(w[1]==true && w[2]==true){
rs = abs(r2.b.x-r2.a.x)*abs(r1.c.y-r2.b.y);
ans-=rs;
}

if(w[2]==true && w[3]==true){
rs = abs(r2.c.y-r2.b.y)*abs(r2.c.x-r1.d.x);
ans-=rs;
}

if(w[3]==true && w[4]==true){
rs = abs(r2.c.x-r2.d.x)*abs(r2.c.y-r1.b.y);
ans-=rs;
}

if(w[1]==true && w[4]==true){
rs = abs(r2.d.y-r2.a.y)*abs(r1.c.x-r2.a.y);
ans-=rs;
}

}else if(c==3){
    // -      :)
}else if(c==4){
if(r1.a.x==r2.a.x && r1.a.y==r2.a.y && r1.b.x==r2.b.x && r1.b.y==r2.b.y && r1.c.x==r2.c.x && r1.c.y == r2.c.y && r1.d.x==r2.d.x && r1.d.y==r2.d.y)
{
    r[touch].a.x = 0;
    r[touch].a.y = 0;
    r[touch].b.x = 0;
    r[touch].b.y = 0;
    r[touch].c.x = 0;
    r[touch].c.y = 0;
    r[touch].d.x = 0;
    r[touch].d.y = 0;

    ans -= calc_s(r1);
}else{
    int p1 = calc_s(r1);
    int p2 = calc_s(r2);
    if(ans<max(p1, p2)){
    ans = max(p1, p2);
    }else if(ans==sum){
    ans = max(p1, p2);
    }
}

}

}



int main(){


cin >> n;
for(int i = 0; i < n; i++){
cin >> r[i].a.x >> r[i].a.y >> r[i].c.x >> r[i].c.y;
if(r[i].a.x > r[i].c.x) swap(r[i].a, r[i].c);
r[i].b.x = r[i].c.x;
r[i].b.y = r[i].a.y;
r[i].d.x = r[i].a.x;
r[i].d.y = r[i].c.y;

ans += calc_s(r[i]);

}
sum = ans;
for(int i = 0; i < n; i++)
    for(int j = i+1; j < n; j++){
        remove_s(have_common(r[i], r[j]), r[i], r[j], j);
    }

cout << ans << endl;
return 0;
}
