/*
TASK: pancakes
LANG: C++
*/

#include<algorithm>
#include<iostream>
#include<iomanip>
#include<cstring>
#include<cstdlib>
#include<sstream>
#include<vector>
#include<cstdio>
#include<string>
#include<cmath>
#include<queue>
#include<set>

#define stop exit(0)
#define nc -1
#define eps 1e-10
#define inf 1000000000
#define mp make_pair

#define fill(array,value) memset(array,value,sizeof(array))
#define f(i,beg,end) for(int i=beg; i<=end; i++)
#define F(i,beg,end) for(int i=beg; i>=end; i--)
#define Max(a,b) ( (a>b)?a:b )
#define Min(a,b) ( (a<b)?a:b )
#define pi 3.1415926535897932384626433832
#define iread(var) scanf("%d",&var)
#define dread(var) scanf("%f",&var)
#define lread(var) scanf("%lld",&var)
#define input(name) freopen(name,"r",stdin)
#define output(name) freopen(name,"w",stdout)
typedef unsigned long long ull;
typedef unsigned int ui;
typedef long double ld;
typedef long long ll;

using namespace std;

ll x, n, t[21];

int check(ll num)
{
    ll xx=0;
    f(i,1,n)
        xx+=(ll)num/t[i];
    
    return (xx>=x);
}

ll solve(ll from, ll to)
{
    ll mid=(from+to)/2;
    if (from>to) return from;
    
    if (check(mid))
        if (!check(mid-1)) return mid;
        else return solve(from,mid-1);
    else return solve(mid+1,to);
}

void init()
{
    cin>>x>>n;
    f(i,1,n)
        cin>>t[i];
}

int main()
{
    init();
    cout<<solve(1,(ll)inf*(inf/10))<<endl;

    return 0;
}