/*
TASK: towers
LANG: C++
*/

#include<algorithm>
#include<iostream>
#include<iomanip>
#include<cstring>
#include<cstdlib>
#include<sstream>
#include<vector>
#include<cstdio>
#include<string>
#include<cmath>
#include<queue>
#include<set>

#define stop exit(0)
#define nc -1
#define eps 1e-10
#define inf 1000000000
#define mp make_pair

#define fill(array,value) memset(array,value,sizeof(array))
#define f(i,beg,end) for(int i=beg; i<=end; i++)
#define F(i,beg,end) for(int i=beg; i>=end; i--)
#define Max(a,b) ( (a>b)?a:b )
#define Min(a,b) ( (a<b)?a:b )
#define pi 3.1415926535897932384626433832
#define iread(var) scanf("%d",&var)
#define dread(var) scanf("%f",&var)
#define lread(var) scanf("%lld",&var)
#define input(name) freopen(name,"r",stdin)
#define output(name) freopen(name,"w",stdout)
typedef unsigned long long ull;
typedef unsigned int ui;
typedef long double ld;
typedef long long ll;

using namespace std;

int n, k, h[15100], x[15100], use[15100];

double calc_cos(int i1, int i2)
{
    double dist=pow(( (x[i2]-x[i1])*(x[i2]-x[i1]) + (h[i2]-h[i1])*(h[i2]-h[i1]) ), 0.5);
    return (h[i1]-h[i2])/dist;
}

void next(int curr)
{
    use[curr]=1;
    
    if (curr>=n) return;
    
    double curr_cos=calc_cos(curr,curr+1); int curr_pos=curr+1;
    f(i,curr+2,n)
    {
        double new_cos=calc_cos(curr,i);
        
        if (x[i]-x[curr]>k) break;
        
        if (new_cos+eps<curr_cos+eps)
        {
            curr_pos=i;
            curr_cos=new_cos;
        }
        else
        {
            //next(curr_pos);
            //return;
            break;
        }
    }
    next(curr_pos);
}

void init()
{
    iread(n); iread(k);
    
    f(i,1,n) 
    {
        iread(x[i]);
        iread(h[i]);
    }
    
    next(1);
    
    int s=0; 
    f(i,1,n)
        s+=use[i];
    cout<<s<<endl;
}

int main()
{
    init();

    return 0;
}