#include <iostream>
#include <algorithm>

using namespace std;

struct point
{
    int x;
    int y;
};

struct rectangle
{
    point a;
    point b;
    point c;
    point d;
    int A;
    int B;
    int S;
};

int length(point a, point b)
{
    if(a.x == b.x)
        return abs(a.y - b.y);
    if(a.y == b.y)
        return abs(a.x - b.x);
    return 0;
}

int type(rectangle a, rectangle b)
{
    if ( (a.c.x > b.d.x) && (a.c.x > b.a.x) && (a.b.x > b.a.x) && (a.b.x > b.d.x) && (a.c.y > b.d.y) && (a.c.y > b.a.y) && (a.b.y < b.a.y) && (a.b.y < b.d.y) )
        return 1;
    if ( (a.c.x > b.b.x) && (a.c.x > b.a.x) && (a.d.x < b.a.x) && (a.d.x < b.b.x) && (a.c.y > b.b.y) && (a.c.y > b.a.y) && (a.a.y > b.a.y) && (a.a.y > b.b.y) )
        return 2;
    if ( (a.a.x < b.d.x) && (a.a.x < b.c.x) && (a.b.x > b.c.x) && (a.b.x > b.d.x) && (a.a.y < b.d.y) && (a.a.y < b.c.y) && (a.b.y < b.c.y) && (a.b.y < b.d.y) )
        return 3;
    if ( (a.a.x < b.b.x) && (a.a.x < b.c.x) && (a.d.x < b.c.x) && (a.d.x < b.b.x) && (a.a.y < b.b.y) && (a.a.y < b.c.y) && (a.d.y > b.c.y) && (a.d.y > b.b.y) )
        return 4;
    if ( (a.c.x > b.a.x) && (a.c.y > b.a.y) )
        return 5;
    if ( (a.b.x > b.d.x) && (a.b.y > b.d.y) )
        return 6;
    if ( (a.a.x > b.c.x) && (a.a.y > b.c.y) )
        return 7;
    if ( (a.d.x > b.b.x) && (a.d.y > b.b.y) )
        return 8;
    return 0;
}

int main()
{
    rectangle rect[100];
    int N = 0;
    cin >> N;
    int S = 0;
    int z1 = 0;
    int z2 = 0;
    int temp = 0;

    if((N < 1) || (N > 100))
        return 0;

    for(int i = 0; i < N; i++)
    {
        cin >> rect[i].a.x
            >> rect[i].a.y
            >> rect[i].c.x
            >> rect[i].c.y;
        rect[i].b.x = rect[i].c.x;
        rect[i].b.y = rect[i].a.y;
        rect[i].d.x = rect[i].a.x;
        rect[i].d.y = rect[i].c.y;
        rect[i].A = length(rect[i].a, rect[i].b);
        rect[i].B = length(rect[i].a, rect[i].d);
        rect[i].S = rect[i].A * rect[i].B;
    }

    cout << type(rect[0], rect[1]) << " = type\n";

    for(int i = 0; i < N; i++)
    {
        S += rect[i].S;
    }

    cout << " S = " << S << endl;

    for(int i = 0; i < N; i++)
    {
        for(int z = i + 1; z < N; z++)
        {

            switch(type(rect[i], rect[z]))
            {
                case 1: z1 = rect[i].c.x - rect[z].a.x; z2 = rect[i].c.y - (rect[i].c.y - rect[z].d.y) - rect[z].a.y; temp = z1 * z2; S -= temp; break;
                case 2: z1 = rect[i].c.y - rect[z].a.y; z2 = rect[i].c.x - (rect[i].c.x - rect[z].b.x) - rect[z].c.x; temp = z1 * z2; S -= temp; break;
                case 3: z1 = rect[z].b.x - rect[i].a.x; z2 = rect[i].d.y - (rect[i].d.y - rect[z].c.y) - rect[z].b.y; temp = z1 * z2; S -= temp; break;
                case 4: z1 = rect[z].c.y - rect[i].b.y; z2 = rect[i].b.x - (rect[i].b.x - rect[z].c.x) - rect[z].d.x; temp = z1 * z2; S -= temp; break;
                case 5: z1 = rect[i].c.x - rect[z].a.x; z2 = rect[i].c.y - rect[z].a.y; cout << "z1 = " << z1 << "\nz2 = " << z2 << endl; temp = z1 * z2; S = S - temp; break;
                case 6: z1 = rect[i].b.x - rect[z].d.x; z2 = rect[z].d.y - rect[i].b.y; temp = z1 * z2; S = S - temp; break;
                case 7: z1 = rect[z].c.x - rect[i].a.x; z2 = rect[z].c.y - rect[i].a.y; temp = z1 * z2; S = S - temp; break;
                case 8: z1 = rect[z].b.x - rect[i].d.x; z2 = rect[i].d.y - rect[z].b.y; temp = z1 * z2; S = S - temp; break;
            }

        }
    }

    cout << S;

    return 0;
}
