#include<stdio.h>
#include<vector>
int n;
const int MAX_VALUE=110000;
int r[10001][10001];
bool used[10001];
int d[10001];
void Dijkstra(int node) {
   int i,j,di;
   for(i=1;i<=n;i++)
      if(r[node][i])
         d[i]=r[node][i];
      else
         d[i]=MAX_VALUE;
   for(i=1;i<=n;i++)
      used[i]=false;
   used[node]=true;
   while(1) {
      j=-1;
      di=MAX_VALUE;
      for(i=1;i<=n;i++)
         if(d[i]<di && !used[i]) {
            di=d[i];
            j=i;
         }
      if(j==-1)
         break;
      used[j]=true;
      for(i=1;i<=n;i++)
         if(r[j][i] && !used[i] && d[i]>d[j]+r[j][i])
            d[i]=d[j]+r[j][i];
   }
}
int main() {
   int x,y,z,i,max=0,a,b,min=MAX_VALUE;
   scanf("%d %d %d",&n,&a,&b);
   for(i=1;i<=10000;i++)
      r[i][i+1]=1;
   for(i=0;i<n;i++) {
      scanf("%d %d %d",&x,&y,&z);
      if(y>max) max=y;
      r[x][y]=z;
      r[y][x]=z;
   }
   n=max;
   Dijkstra(a);
   for(i=b;i<=n;i++)
      if(d[i]<min)
         min=d[i];
   printf("%d\n",min);
   return 0;
}