#include <cstdio>
#include <ctime>

const int MAXN = 2 << 14;

int x[MAXN] , h[MAXN];
int n , k;


void read()
{
    scanf ( "%d%d" , &n , &k );

    int i;
    for (i = 0; i < n; ++i)
        scanf ( "%d%d" , x + i , h + i );
}

bool under ( int x1 , int y1 , int x2 , int y2 , int x3 , int y3 )
{
    x2 -= x1;
    y2 -= y1;

    x3 -= x1;
    y3 -= y1;

    return (x2 * y3 - x3 * y2) < 0;
}

/*
int can ( int pos , int left )
{
    if ( pos == n - 1 && left >= 0 )
        return 1;
    if ( left == 0 )
        return 0;
    if ( left > 0 && pos + 1 == n - 1 )
        return 1;

    int i;
    for (i = pos + 2; i < n; ++i)
    {
        if ( under ( x[pos] , h[pos] , x[i] , h[i] , x[i - 1] , h[i - 1] ) && x[i] - x[pos] <= k )
        {
            if (i == n - 1 && left > 0 ) return 1;
            continue;
        }
        return can ( i - 1 , left - 1 );
    }
    return 0;
}
*/

int go ( int pos )
{
    if ( pos == n - 1 )
        return 0;

    if (  pos + 1 == n - 1 )
        return 1;

    int i;
    for (i = pos + 2; i < n; ++i)
    {
        if ( under ( x[pos] , h[pos] , x[i] , h[i] , x[i - 1] , h[i - 1] ) && x[i] - x[pos] <= k )
        {
            if (i == n - 1 ) return 1;
            continue;
        }
        return go ( i - 1 ) + 1;
    }
}

void solve()
{
    if ( n == 2 )
    {
        puts ( "2" );
        return;
    }

    /*
    int l = 1 , r = n + 1 , m;
    while ( l + 1 != r )
    {
        m = (l + r) >> 1;
        if ( can ( 0 , m - 1 ) > 0 )
            r = m;
        else
            l = m;
    }

    printf ( "%d\n" , r );
    */

    printf ( "%d\n" , go ( 0 ) + 1 );

    //printf ( "%.6lf\n" , clock() / CLOCKS_PER_SEC );
}

int main()
{
    read();
    solve();

    return 0;
}
