#include <cstdio>
#include <iostream>

using namespace std;



const int MAXN = 1 << 14;

int N, K;

int x[MAXN], h[MAXN];

int dp[MAXN];

void scan(){
    scanf ( "%d%d", &N, &K );
    K *= 1000;
    scanf ( "%d%d", &x, &h );
    x[0] *= 1000;

    for ( int i = 1; i < N; ++i ){
        scanf ( "%d%d", x + i, h + i );
        x[i] *= 1000;
        if ( x[i] == x[i - 1] ){
            if ( h[i - 1] < h[i] )
                h[i - 1] = h[i];
            --i;
            --N;
        }
    }
}

void solve(){
    dp[0] = 1;

    for ( int i = 1; i < N; ++i ){
        dp[i] = dp[i - 1] + 1;
        long long dx = x[i] - x[i - 1], dh = h[i] - h[i - 1];

        for ( int j = i - 2; j >= 0 ; --j ){
         //   cout << i << " " << j << " " << x[i] << " " << x[j] << " " << K << endl;
            if ( x[i] - x[j] > K ) break;

            long long tdx = x[i] - x[j], tdh = h[i] - h[j];

            if ( dh * tdx > tdh * dx ){
                if ( dp[i] > dp[j] + 1 )
                    dp[i] = dp[j] + 1;
                dx = tdx;
                dh = tdh;
            }

      //      cout << i << " " << j << " " << dh << " " << dx << " " << tdh << " " << tdx << endl;
        }
    }

  //  for ( int i = 0; i < N; ++i )
    //    cout << dp[i] << " ";

//    cout << endl;

    printf ( "%d\n", dp[N - 1] );
}
int main(){
    scan();
    solve();
}
