#include <iostream>

using namespace std;

int n, k;

unsigned long long int prec[80];

unsigned long long int comp(int u)
{
	if (u < 2) return 0;

	if (prec[u] > 0)
		return prec[u];
	else
	{
		for (int i = 2; (i <= k) && (i < u); i++)
		{
			if (u % i == 0)
			{
				prec[u] += comp(u/i);
			}
			prec[u] += comp(u - i);
		}

		if (u <= k)
			prec[u] += 1; // add one for simply u, without any signs

		return prec[u];
	}
}

int main()
{
	//scanf("%d %d", &n, &k);
	cin >> n >> k;

	//printf("%d\n", comp(n));
	cout << comp(n) << endl;

	return 0;
}
