#include <cstdio>
#include <algorithm>
using namespace std;
int n;
struct line {
    int x, y1, y2;
    bool isOpening;
} array[256];
int coverage[1 << 15];
bool cmp(line a, line b) {
    if (a.x == b.x) {
        return a.isOpening;
    }
    return a.x < b.x;
}
int getCoverage() {
    int ans = 0;
    for (int i = 0;i <= 20000; ++i) {
        if (coverage[i] > 0) ans++;
    }
    return ans;
}
int main() {
    scanf("%d", &n);
    int fx, fy, sx, sy;
    for (int i = 0;i < n; ++i) {
        scanf("%d %d %d %d", &fx, &fy, &sx, &sy);
        fx += 10000;
        fy += 10000;
        sx += 10000;
        sy += 10000;
        array[i].x = min(fx, sx);
        array[i].y1 = min(fy, sy);
        array[i].y2 = max(fy, sy);
        array[i].isOpening = true;
        array[n + i].x = max(fx, sx);
        array[n + i].y1 = min(fy, sy);
        array[n + i].y2 = max(fy, sy);
        array[n + i].isOpening = false;
    }
    n *= 2;
    sort(array, array + n, cmp);
    for (int i = array[0].y1; i < array[0].y2; ++i) {
        coverage[i]++;
    }
    int sum = 0;
    for (int i = 1; i < n; ++i) {
        int covered = getCoverage();
        sum += covered * (array[i].x - array[i - 1].x);
        for (int j = array[i].y1; j < array[i].y2; ++j) {
            if (array[i].isOpening) coverage[j]++;
            else coverage[j]--;
        }
    }
    printf("%d\n", sum);
    return 0;
}
