#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;
struct PointT{
    unsigned X, YBegin, YEnd;
    bool Add;
    PointT(unsigned x, unsigned y1, unsigned y2, bool a):X(x),YBegin(y1),YEnd(y2),Add(a){
        return;
    }
};
inline bool operator<(PointT a, PointT b){
    return a.X<b.X;
}
unsigned Covers[32768], N, i, j, Area, PrevX, Covered;
int A, B, C, D;
vector<PointT> Points;
int main(){
    scanf("%u", &N);
    for(i=0;i<N;i++){
        scanf("%d %d %d %d", &A, &B, &C, &D);
        A+=10000;
        B+=10000;
        C+=10000;
        D+=10000;
        Points.push_back(PointT(min(A, C), min(B, D), max(B, D), 1));
        Points.push_back(PointT(max(A, C), min(B, D), max(B, D), 0));
    }
    sort(Points.begin(), Points.end());
    PrevX=Points[0].X;
    for(size_t i=0;i<Points.size();i++){
        Area+=Covered*(Points[i].X-PrevX);
        PrevX=Points[i].X;
        if(Points[i].Add){
            for(j=Points[i].YBegin;j<Points[i].YEnd;j++){
                if(Covers[j]==0) Covered++;
                Covers[j]++;
            }
        }else{
            for(j=Points[i].YBegin;j<Points[i].YEnd;j++){
                Covers[j]--;
                if(Covers[j]==0) Covered--;
            }
        }
    }
    printf("%u\n", Area);
    return 0;
}