#include <iostream>
using namespace std;

struct fr
{
    unsigned long long n, d;
};

unsigned long long gcd (unsigned long long a, unsigned long long b)
{
    while (a != b)
    {
        if (a > b)
        {
            if ( !(a % b))
            {
                a = b;
            }
            else
            {
                a %= b;
            }
        }
        if (b > a)
        {
            if ( !(b % a))
            {
                b = a;
            }
            else
            {
                b %= a;
            }
        }
    }
    return a;
}

unsigned long long lcm (unsigned long long a, unsigned long long b)
{
    return (a * b) / gcd (a, b);
}

int main ()
{
    int n;
    cin >> n;

    unsigned long long Clcm;
    fr sum; sum.n = 1; sum.d = 1;
    for (int i = 2; i <= n; i ++)
    {
        unsigned long long div = gcd (sum.n, sum.d);
        sum.n /= div; sum.d /= div;

        Clcm = lcm (sum.d, i);
        sum.n = (sum.n * (Clcm / sum.d)) + (Clcm / i);
        sum.d = Clcm;
    }

    cout << sum.n / sum.d << ' ' << sum.n % sum.d << ' ' << sum.d << '\n';
    return 0;
}
