#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <queue>
#include <vector>
#include <map>
#include <string>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <numeric>

using namespace std;

int K,N;
long long dp[100];

long long get(int n){
    //cout<<n<<endl;
    if(n==0)
        return 1;
    if(dp[n]!=-1)
        return dp[n];
    dp[n]=0;
    for(int i=2; i<=K; i++){
        if(n%i==0 && n/i>=2)
            dp[n]+=get(n/i);
    }
    for(int i=2; i<=K; i++){
        if(n-i>=0)
            dp[n]+=get(n-i);
    }
    return dp[n];
}

int main(){
	//freopen("expression.in","r",stdin);
	//freopen("expression.out","w",stdout);
	memset(dp,-1,sizeof(dp));
    scanf("%d %d",&N,&K);
    printf("%I64d\n",get(N));
	return 0;
}
