#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <queue>
#include <vector>
#include <map>
#include <string>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <numeric>

using namespace std;

const int MAXN=15000;

int H[MAXN+1],X[MAXN+1];
int N,K,L;
int dist[MAXN+1];

int search(int at){
    int l=0;
    int r=X[at]-1;
    int req=max(X[at]-K,1);
    int mid;
    while(l<r){
        //cout<<l<<" "<<r<<endl;
        mid=(l+r)/2;
        if(X[mid]<req){
            l=mid+1;
        }
        else{
            r=mid;
        }
    }
    return l;
}

int main(){
    //freopen("towers.in","r",stdin);
    scanf("%d %d",&N,&K);
    for(int i=1; i<=N; i++){
        scanf("%d %d",&X[i],&H[i]);
    }
    dist[1]=1;
    for(int i=2; i<=N; i++){
        int from=search(i);
        int A=H[i-1]-H[i];
        int B=X[i]-X[i-1];
        int C=H[i]*X[i-1]-X[i]*H[i-1];
        int last=i-1;
        for(int j=i-2; j>=from; j--){
            if(A*X[j]+B*H[j]+C>0){
                A=H[j]-H[i];
                B=X[i]-X[j];
                C=H[i]*X[j]-X[i]*H[j];
                last=j;
            }
        }
        dist[i]=dist[last]+1;
    }
    printf("%d\n",dist[N]);
	return 0;
}
