#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

int absolute(int i)
{
    if (i >= 0) return i;
    else return -i;
}

int area(int x1, int y1, int x2, int y2)
{
    return absolute(x1 - x2) * absolute(y1-y2);
}

int area_of_both(int x11, int y11, int x12, int y12, int x21, int y21, int x22, int y22)
{
    int lby1 = y11, lby2 = y21, uby1 = y12, uby2 = y22, lbx1 = x11, lbx2 = x21, rbx1 = x12, rbx2 = x22;
    bool p11 = false, p12 = false, p13 = false, p14 = false, p21 = false, p22 = false, p23 = false, p24 = false;
    if ((x11 >= lbx2) && (x11 <= rbx2) && (y11 >= lby2) && (y11<=uby2)) p11 = true;
    if ((x12 >= lbx2) && (x12 <= rbx2) && (y11 >= lby2) && (y11<=uby2)) p12 = true;
    if ((x11 >= lbx2) && (x11 <= rbx2) && (y12 >= lby2) && (y12<=uby2)) p14 = true;
    if ((x12 >= lbx2) && (x12 <= rbx2) && (y12 >= lby2) && (y12<=uby2)) p13 = true;
    if ((x21 >= lbx1) && (x21 <= rbx1) && (y21 >= lby1) && (y21<=uby1)) p21 = true;
    if ((x22 >= lbx1) && (x22 <= rbx1) && (y21 >= lby1) && (y21<=uby1)) p22 = true;
    if ((x21 >= lbx1) && (x21 <= rbx1) && (y22 >= lby1) && (y22<=uby1)) p24 = true;
    if ((x22 >= lbx1) && (x22 <= rbx1) && (y22 >= lby1) && (y22<=uby1)) p23 = true;

    if (!p11 && !p12 && !p13 && !p14 && !p21 && !p22 && !p23 && !p24) return 0;
    else
    {
        vector<int>xes, yes;
        xes.push_back(x11);
        xes.push_back(x12);
        xes.push_back(x21);
        xes.push_back(x22);
        yes.push_back(y11);
        yes.push_back(y12);
        yes.push_back(y21);
        yes.push_back(y22);
        sort(xes.begin(), xes.end());
        sort(yes.begin(), yes.end());
        int x1 = xes[1], y1 = yes[1], x2 = xes[2], y2 = yes[2];
        return area (x1, y1, x2, y2);
    }
}

int main()
{
    int n, x1[100], y1[100], x2[100], y2[100];
    long long sum_of_areas = 0, sum_of_all = 0;
    scanf ("%d", &n);

    for (int i = 0; i < n; i++)
    {
        scanf ("%d%d%d%d", &x1[i], &y1[i], &x2[i], &y2[i]);

        sum_of_areas += area (x1[i], y1[i], x2[i], y2[i]);

        if ((x1[i] == x2[i]) || (y1[i] == y2[i]))
        {
            i--;
            n--;
        }
        else
        {
            int minx, maxx, miny, maxy;
            if (x2[i] > x1[i])
            {
                maxx = x2[i];
                minx = x1[i];
            }
            else
            {
                maxx = x1[i];
                minx = x2[i];
            }
            if (y2[i] > y1[i])
            {
                maxy = y2[i];
                miny = y1[i];
            }
            else
            {
                maxy = y1[i];
                miny = y2[i];
            }
            x1[i] = minx;
            x2[i] = maxx;
            y1[i] = miny;
            y2[i] = maxy;
        }
    }

    for (int i = 0; i < n-1; i++)
        for (int j = i + 1; j < n; j++)
            sum_of_all += area_of_both (x1[i], y1[i], x2[i], y2[i], x1[j], y1[j], x2[j], y2[j]);

    printf ("%d\n", sum_of_areas - sum_of_all);

    return 0;
}
