#include <iostream>

using std::cin;
using std::cout;
using std::endl;

unsigned long long dyn[80][81];//[used signs][sum] = ways
int N, K;

int main()
{
    cin >> N >> K;

    for(int i = 0;i < N/2;i++)
        for(int j = 0;j <= N;j++)
            dyn[i][j] = 0;

    for(int i = 2;i <= K;i++)
        dyn[0][i] = 1;

    for(int i = 1;i < N/2;i++)//N/2 is reached only with 2+2+2+...
    {
        for(int j = 2;j <= N;j++)//for each number 2, 3,..., K
        {
            if(dyn[i-1][j] == 0)
                continue;

            for(int q = 2; q <= K;q++)
            {
                if(j + q <= N)
                    dyn[i][j+q] += dyn[i-1][j];
                if(j * q <= N)
                    dyn[i][j*q] += dyn[i-1][j];
            }
        }
    }

    unsigned long long ans = 0;
    for(int i = 1;i < N/2;i++)
        ans += dyn[i][N];

    cout << ans << endl;

    return 0;
}
