#include <iostream>
#include <stdio.h>

#define mp make_pair
#define X first
#define Y second

using namespace std;

const int MAXN = 15000 + 10;

typedef long long LL;
typedef pair<LL, LL> Point;

int n, k, x[MAXN], h[MAXN];
int dp[MAXN];

void read() {
    scanf("%d %d", &n, &k);
    for(int i = 0; i < n; i ++)
        scanf("%d %d", &x[i], &h[i]);
}

int d(Point A, Point B, Point C) {
    LL det = (A.X * B.Y + B.X * C.Y + C.X * A.Y) - (B.X * A.Y + C.X * B.Y + A.X * C.Y);
    if(det < 0) return -1;
    if(det > 0) return 1;
    return 0;
}

void solve() {
    for(int i = 0; i < n; i ++)
        dp[i] = MAXN;

    dp[0] = 1;
    for(int i = 1; i < n; i ++) {
        bool fl = false;
        Point now = mp(x[i] * 1000, h[i]), highest, test;

        for(int j = i - 1; j >= 0; j --) {
            if(x[i] - x[j] > k) break;
            test = mp(x[j] * 1000, h[j]);
            if(!fl || d(now, highest, test) < 0) {
                if(dp[i] > dp[j] + 1)
                    dp[i] = dp[j] + 1;
                highest = test;
                fl = true;
            }
        }
    }

    cout << dp[n - 1] << endl;
}

int main() {
    read();
    solve();

    return 0;
}
