#include <iostream>
#include <cstdio>
#include <algorithm>
#define MAXN 101
#define MAX 10001

using namespace std;

int n, sz;
int u[2 * MAX + 1][2];

typedef unsigned long long ll;
ll ans;

struct side { int x, y1, y2; char type; } a[2 * MAXN];
bool cmp(side a, side b) { return (a.x != b.x) ? (a.x < b.x) : (a.type == 'o'); }

void calc(int ind) {
    if(ind == 0) return;

    int len = 0, i;
    for(i=0; i<=2*MAX+1; i++)
    if(u[i][1] > 0) len++;

    ans += ll(len) * ll(a[ind].x - a[ind - 1].x);
}

void upd(int ind) {
    int i, add;

    if(a[ind].type == 'o') add = 1; else add = -1;

    i = a[ind].y1;
    u[i][0] += add;
    for(++i; i<=a[ind].y2; i++) u[i][1] += add;
}

int main() {
    int i;
    int x1, y1, x2, y2;

    scanf("%d", &n);
    for(i=0; i<n; i++) {
        scanf("%d%d%d%d", &x1, &y1, &x2, &y2);
        if(x1 > x2) swap(x1, y1), swap(x2, y2);
        x1 += MAX, y1 += MAX, x2 += MAX, y2 += MAX;

        a[sz].x = x1, a[sz].y1 = min(y1, y2), a[sz].y2 = max(y1, y2), a[sz].type = 'o', sz++;
        a[sz].x = x2, a[sz].y1 = min(y1, y2), a[sz].y2 = max(y1, y2), a[sz].type = 'c', sz++;
    }

    sort(a, a+sz, cmp);

    for(i=0; i<sz; i++)
    calc(i),
    upd(i);

    printf("%llu\n", ans);
    return 0;
}
