#include <cstdio>

#define MAXN 15000

using namespace std;

int x[MAXN+6],h[MAXN+6],dp[MAXN+6];

struct tang
{
    int a,b,k;
};

inline tang compute_tg(const int &i, const int &j)
{
    tang ans;
    ans.a = h[j] - h[i];
    ans.b = x[j] - x[i];
    ans.k = 1;
    if ( ans.a < 0 )
    {
        ans.a = -ans.a;
        ans.k *= (-1);
    }
    if ( ans.b < 0 )
    {
        ans.b = -ans.b;
        ans.k *= (-1);
    }
    return ans;
}

inline bool greater(const tang &u, const tang &v)
{
    int h,g;
    h = u.a*u.k*v.b;
    g = v.a*v.k*u.b;
    if ( h > g ) return true;
    return false;
}

int main()
{
    tang mini,tg;
    int k,n,i,j;
    scanf ("%d%d",&n,&k);

    for ( i=1; i<=n; i++ )
    {
        scanf ("%d%d",&x[i],&h[i]);
        if ( i == 1 ) dp[1] = 1;
        else
        {
            mini.a = 3000;
            mini.b = 1;
            mini.k = 1;
            dp[i] = n+2;
            for ( j=i-1; j>=1 && x[i] - x[j] <= k; j-- )
            {
                tg = compute_tg(j,i);
                if ( greater(mini,tg) )
                {
                    mini = tg;
                    if ( dp[j] + 1 < dp[i] ) dp[i] = dp[j] + 1;
                }
            }
        }
    }

    printf ("%d\n",dp[n]);
}
