#include<cstdio>
#include<stack>
#include<cmath>
#include<iostream>

using namespace std;

struct towers
{
    int h,x;
};

const double e=0.0001;
int n,k;
towers t[31000];
int cnt=2;
int st[2][2];

void Init()
{
    scanf("%d %d", &n, &k);
    for (int i=0; i<n; i++)
    {
        scanf("%d %d", &t[i].x, &t[i].h);
    }
}

bool is_pos(int a, int b, int c)
{
    int dist3 = t[b].x-t[c].x;
    if (dist3>k) return false;
    int dist = t[b].x-t[a].x; //if (dist<0) dist=-dist;
    if (dist>k) return false;
    double p=(double)((double)((double)t[a].h-(double)t[b].h)/dist); if (p<0) p=-p;
    int dist2 = t[c].x - t[a].x; //if (dist2<0) dist2=-dist2;
    if (dist2>k) return false;
    double h=(double)(p*dist2);
    double q;
    if (t[a].h>t[b].h) q=t[a].h-h;
    else q=t[a].h+h;
    if (q-t[c].h>e) return true;
    return false;
}

void sol()
{
    stack<int> s; s.push(0); s.push(1);
    for (int i=2; i<n; i++)
    {
        //int p=s.top();
        int p=s.top();
        s.pop();
        while (is_pos(s.top(), i, p) && s.size()>1) {p=s.top(); s.pop();}
        s.push(p);
        s.push(i);
    }
    printf("%d\n", s.size());
    //printf("------------------------------------------------------------------\n");
    //while(!s.empty()) {printf("%d %d\n", t[s.top()].x, t[s.top()].h); s.pop();}
}

int main()
{
    Init();
    sol();
    return 0;
}
/*
8 9
1 3
2 7
5 8
6 2
9 10
12 20
13 18
15 16
*/
