#include <cstdio>
#include <algorithm>
#include <queue>

using namespace std;

class Pan
{
public:
	int cost, total;
	
	Pan() {}
	Pan(int _cost, int _total)
	{
		cost = _cost;
		total = _total;
	}
	
	bool operator< (const Pan &p) const
	{
		return total > p.total;
	}
};

unsigned long long x;
int n;
priority_queue <Pan> pq;

void input()
{
	scanf("%llu%d", &x, &n);
	//printf("%llu %d\n", x, n);
	
	for (int i = 1; i <= n; i++)
	{
		int tigan;
		scanf("%d", &tigan);
		pq.push(Pan(tigan, tigan));
	}
}

void solve()
{
	unsigned long long ans;
	while (x--)
	{
		Pan p = pq.top();
		pq.pop();
		//printf("%d %d\n", p.cost, p.total);
		
		ans = p.total;
		p.total += p.cost;
		pq.push(p);
	}
	
	printf("%llu\n", ans);
}

int main()
{
	input();
	//show();
	solve();
	
	return 0;
}