#include <iostream>
#include <vector>
#include <cstdio>
using namespace std;

struct seg
{
       int x,y,v;
       seg(){}
       seg(int _x, int _y, int _v)
       {
               x=_x;
               y=_y;
               v=_v;
       }
       bool operator<(const seg a)
       const{
             return x<a.x;
             }

};

int dp[10010];


int calc(int a, int b, int d, int v)
{
    if(d<=b) return v;
    else return v+d-b;
}

int main()
{
    int n,a,b;
   scanf("%d%d%d", &n, &a, &b);
    
    seg s[10006];
    
    int x,y,z;
    for(int i=0; i<n; i++)
    {
            scanf("%d%d%d", &x, &y, &z);
            s[i]=seg(x,y,z);
    }
    
    sort(s,s+n);
    
    dp[0]=0;
    
    for(int i=1; i<=n; i++) dp[i]=s[i-1].x-a;
    dp[n+1]=b-a;
    
    for(int i=1; i<=n; i++)
    {
            if(s[i-1].x<a) continue;
            if(s[i-1].x>b) break;
            for(int j=i-1; j>0; j--)
            {
                    if(j==0) dp[i]=min(dp[i],s[i-1].x-a);
                    if(s[j-1].x<a) break;
                    dp[i]=min(dp[i],dp[j]+calc(s[j-1].x, s[j-1].y, s[i-1].x, s[j-1].v));
            }
    }
    
    
    int res=dp[n+1];
    
    for(int i=n; i>0; i--)
    {
            if(s[i-1].x<a) break;
            if(s[i-1].x>b) continue;
            res=min(res,dp[i]+calc(s[i-1].x, s[i-1].y, b, s[i-1].v));
    }
    
    printf("%d\n", res);
    
    return 0;
}
