#define DBG

#include <iostream>

#define uint unsigned int

using namespace std;

typedef enum {
	End = 0
	, Mul = 1
	, Add = 2
} op;

uint exp[82] = {};
uint explength = 0;
uint n,k;

inline bool isOp(uint test)
{
	return (test & 0x01);	// ops are not divisable by two
}

uint eval()
{
	uint res = exp[0];
	uint i = 1;
	#ifdef DBG
		cout << "[eval] ";
	#endif
	while (exp[i] != End) {
		#ifdef DBG
			cout << exp[i - 1];
		#endif
		if ((op)exp[i] == Mul) {
			#ifdef DBG
				cout << "*";
			#endif
			res *= exp[i + 1];
		} else {
			#ifdef DBG
				cout << "+";
			#endif
			res += exp[i + 1];
		}
		i += 2;
	}
	#ifdef DBG
		cout << exp[i - 1] << " = " << res << endl;
	#endif
	return res;
}

void inc()
{
	uint i = 0;
	uint init;
	uint max;
	while ( 1 ) {
		if (isOp(i)) {
			init = Mul;
			max = Add;
			if (exp[i + 1] < 2) {
				exp[i + 1] = 2;
				explength = i + 2;
			}
		} else {
			max = k;
			init = 2;
		}
		if (exp[i] >= max)
			exp[i] = init;
		else {
			++exp[i];
			break;
		}
		++i;
	}
}

int main ()
{
	cin >> n >> k;
	uint count = 0;
	bool havenew = true;
	bool foundfirst = false;
	uint val;
	uint oldlength = explength;
	while ( havenew || !foundfirst) {
		havenew = false;
		oldlength = explength;
		do {
			inc();
			val = eval();
			#ifdef DBG
				cout << "length " << explength << endl;
			#endif
			if (val == n) {
				++count;
				foundfirst = true;
				havenew = true;
			}
		} while ( explength == oldlength );
	}
	cout << count;
}