#include<cstdio>
#include<vector>
#include<queue>
using namespace std;

vector<int> g[15000];
int dist[15000], n, k, x[15000], y[15000];

void read() { 
    
    int i;
    scanf("%d%d", &n, &k);
    
    for( i=0; i<n; ++i ) 
        scanf("%d%d", &x[i], &y[i]);
}

int det ( int p1, int p2, int p3 ) {
    
    return x[p1]*(y[p2]-y[p3]) + x[p3]*(y[p1]-y[p2]) + x[p2]*(y[p3]-y[p1]);
}

bool check ( int p, int q ) {
    
    int i;
    
    for( i=p+1; i<q; ++i ) 
        if( det( p, q, i ) >= 0 ) return 0;
    
    return 1;
}

void make () {
    
    int i, j;
    
    for( i=0; i<n; ++i ) 
        for( j=i+1; x[j]-x[i]<=k && j<n; ++j ) 
            if( check( i, j ) ) g[i].push_back(j);
}

void bfs() {
    
    int i;
    queue<int> q;
    q.push(0);
    dist[0]=1;
    
    while( q.size() ) {
        
        int cur=q.front();
        q.pop();
        
        for( i=0; i<g[cur].size(); ++i ) 
            if( !dist[g[cur][i]] ) {
                
                dist[g[cur][i]]=dist[cur]+1;
                q.push( g[cur][i] );
            }
            
    }
}
            

void solve () {
    
    make();
    bfs();
    printf("%d\n", dist[n-1]);
}
main () {
    
    read();
    solve();
    return 0;
}
