#include <cstdio>
#include <cstring>
#include<iostream>
using namespace std;

int n , k;
long long dp[128];

void read() {
    scanf ( "%d%d" , &n, &k );
}

long long go ( int x ) {
    if ( x > n ) return 0;
    if ( x == n ) return 1;
    long long &ans = dp[x];
    if ( ans != -1 ) return ans;
    ans = 0;
    
    int i;
    
    for (i = 2; i <= k; i++) {
        ans += go ( x + i );
        ans += go ( x * i );
    }
    
    return ans;
}

void solve() {
    memset ( dp , -1 , sizeof dp );
    int i;
    long long ans = 0;
    
    for (i = 2; i <= k; i++) {
        ans += go ( i );
    }
    
    cout << ans << '\n';
}

int main() {
    read();
    solve();
    
    return 0;
}
