#include <cstdio>
#include <vector>
#include<iostream>
#include <algorithm>
using namespace std;

const int MAX = 15005;

int n, k;
long long a[MAX], b[MAX];
int dp[MAX];

void read() {
    int i;
    
    cin >> n >>k;
    k*=1000;
    for (i = 1; i <= n; i++) {
        cin>>a[i]>>b[i];
        a[i] *= 1000;
    }
}

int cmp ( pair < pair < int,int>,int> a , pair < pair < int,int>,int> b ) {
    long long c , d;
    c = a.first.second * b.first.first;
    d = a.first.first *b.first.second;
    
    if ( c == d ) {
        return a.first.first<b.first.first;
    }
    return c<d;
}

void solve() {
    int i, j;
    int t , mx;
    
    for (i = 1; i <= n; i++) {
        dp[i] = n + 1;
    }
    
    dp[1] = 1;
    for (i = 2; i <= n; i++) {
        t = -1;
        
        vector < pair < pair < int,int>,int> > f;
        for (j = i - 1; j >= 1; j--) {
            if ( a[i] - a[j] > k ) {
                break;
            }
            
            f.push_back(make_pair(make_pair(a[i] - a[j] , b[i] - b[j] ), j));
        }
        
    //    printf ("%d\n" , (int)f.size());
        
        sort (f.begin(),f.end(),cmp);
        mx = 0;
        
        for (j = 0; j < (int)f.size(); j++) {
      //      printf ( "%d " , f[j].second );
            if ( f[j].second < mx ) continue;
            
            dp[i] = min ( dp[i] , dp[ f[j].second ] + 1 );
            
            if ( f[j].second > mx ) mx=f[j].second;
        }
     //   printf ("\n");
    }
    
    printf ( "%d\n" , dp[n] );
}

int main() {
    read();
    solve();
    
    return 0;
}
