#include <stdio.h>
#define MAXN 15003
using namespace std;

bool DEBUG = false;

int best=0;
int n,k;
char vis[MAXN][MAXN];
int x[MAXN];
int h[MAXN];

bool isVis(int a,int b,int c) {
    double d1 = ((double)(h[c]-h[a]))/((double)(x[c]-x[a]));
    double d2 = ((double)(h[b]-h[a]))/((double)(x[b]-x[a])) ;
    if(d1>d2)
        return true;
    else
        return false;
}

void conVis() {
    int i,j,q;
    int highest,ih;
    for(i=0;i<n;i++)
        for(j=i+1;j<n;j++) {
                if((x[j]-x[i])>k)
                    break;
                if(j==(i+1)){
                    vis[i][j] = 1;
                    vis[j][i] = 1;
                }
                else{
                    highest = h[i+1];
                    ih = i+1;
                    for(q=i+2;q<j;q++){
                        if(h[q]>highest) {
                            highest = h[q];
                            ih = q;
                        }
                    }

                    vis[i][j] = isVis(i,ih,j);
                    vis[j][i] = vis[i][j];
                }

        }
}

void DFS(int s,int curr) {
    if(s==(n-1)) {
        if(best<curr)
            best=curr;
        return;
    }
    else {
        for(int i=s+1;i<n;i++)
                if(vis[i][s])
                    DFS(i,curr+(i-s-1));
    }
}


int maxDFS() {
    DFS(0,0);
    return best;
}

int main() {
    int i,j;
    scanf("%d %d",&n,&k);
    for(i=0;i<n;i++) {
        scanf("%d %d",&(x[i]),&(h[i]));
        for(int j=0;j<n;j++) {
            vis[i][j]=0;
        }
    }
    conVis();
    if(DEBUG)
        for(i=0;i<n;i++)
            for(j=0;j<n;j++)
                if(vis[i][j])
                    printf("%d %d\n",i,j);

    int ans = maxDFS();
    printf("%d\n",n-ans);
    return 0;
}

