#include <cstdio>
#include <algorithm>
using namespace std;
const int MAX = 1 << 20;
int n, start, end;
int stop[1 << 20];
struct card {
    int start, end;
    int before;
    int value;
} cards[1 << 14];
bool cmp(card a, card b) {
    return a.start < b.start;
}
int main() {
    for (int i = 0;i < 1 << 20; ++i) {
        stop[i] = MAX;
    }
    scanf("%d %d %d", &n, &start, &end);
    stop[start] = 0;
    int a, b, value;
    int count = 0;
    for (int i = 0;i < n; ++i) {
        scanf("%d %d %d", &a, &b, &value);
        if (b <= start) continue;
        if (a < start) a = start;
        if (end <= a) continue;
        if (end < b) b = end;
        if (value >= b - a) continue;
        cards[count].start = a;
        cards[count].end = b;
        cards[count].value = value;
        count++;
    }
    n = count;
    sort(cards, cards + n, cmp);
    int l, m, r;
    for (int i = start; i < end; ++i) {
        if (stop[i] + 1 < stop[i + 1]) {
            stop[i + 1] = stop[i] + 1;
        }
        l = -1;
        r = n - 1;
        while (l + 1 < r) {
            m = (l + r) / 2;
            if (cards[m].start >= i) r = m;
            else l = m;
        }
        if (r == 0 && cards[0].start > i) continue;
        if (r == n - 1 && cards[r].end <= i) continue;
        for (; r < n && cards[r].start <= i; ++r) {
            if (stop[cards[r].end] > stop[i] + cards[r].value) {
                stop[cards[r].end] = stop[i] + cards[r].value;
            }
        }
    }
    printf("%d\n", stop[end]);
    return 0;
}
