#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
using namespace std;
unsigned To[32768], StopID[1000000];
vector<unsigned> Stops;
vector<pair<unsigned,unsigned> > Dist[32768];
unsigned Input[32768][3];
unsigned N, A, B, i, j, BStop, AStop;
priority_queue<pair<unsigned,unsigned>, vector<pair<unsigned,unsigned> >, greater<pair<unsigned,unsigned> > > Cards;
int main(){
    scanf("%u %u %u", &N, &A, &B);
    A--;
    B--;
    for(i=0;i<N;i++){
        scanf("%u %u %u", Input[i], Input[i]+1, Input[i]+2);
        Input[i][0]--;
        Input[i][1]--;
        Stops.push_back(Input[i][0]);
        Stops.push_back(Input[i][1]);
    }
    Stops.push_back(A);
    Stops.push_back(B);
    
    sort(Stops.begin(), Stops.end());
    Stops.erase(unique(Stops.begin(), Stops.end()), Stops.end());
    
    for(i=0;i<Stops.size();i++){
        StopID[Stops[i]]=i;
    }
    AStop=StopID[A];
    BStop=StopID[B];
    
    for(i=0;i<N;i++){
        Dist[StopID[Input[i][0]]].push_back(make_pair(StopID[Input[i][1]], Input[i][2]));
    }
    
    for(i=0;i<=AStop;i++){
        To[i]=0;
        for(j=0;j<Dist[i].size();j++){
            Cards.push(make_pair(To[i]+Dist[i][j].second, Dist[i][j].first));
        }
    }
    
    for(i=AStop+1;i<=BStop;i++){
        while(!Cards.empty()&&Cards.top().second<i) Cards.pop();
        To[i]=To[i-1]+Stops[i]-Stops[i-1];
        if(!Cards.empty()&&Cards.top().first<To[i]) To[i]=Cards.top().first;
        for(j=0;j<Dist[i].size();j++){
            Cards.push(make_pair(To[i]+Dist[i][j].second, Dist[i][j].first));
        }
    }
    printf("%u\n", To[BStop]);
    return 0;
}