#include <cstdio>

#define MAXN 10000
#define MAXK 1000000

int K, A, B, N;

class Line
{
public:
    int start, end, prize;
    bool b;

    Line() { this->b = false; }

    Line(int s, int e, int p)
    {
        this->start = s;
        this->end = e;
        this->prize = p;
        this->b = false;
    }

    void Read() { scanf("%d %d %d", &this->start, &this->end, &this->prize); }
    void Print() { printf("%d %d %d\n", this->start, this->end, this->prize); }
    bool Contain(int stop) { return this->start < stop && stop <= this->end; }
} lines[MAXN];


int minp[MAXK];

int GetMinP(int stop)
{
    if(stop > A) return minp[stop];
    else return 0;
}

int main()
{
    scanf("%d %d %d", &N, &A, &B);
    for(int i = 0; i < N; i++)
        lines[i].Read();

    /*
    for(int i = 0; i < N; i++)
        lines[i].Print();
    */
    minp[A] = 0;
    int newPrize;
    bool findLine;
    for(int j, i = A+1; i <= B; i++)            // i - current stop
    {
        findLine = false;
        for(j = 0; j < N; j++)                  // za vsqka liniq koqto sadarja i
            if(lines[j].Contain(i))
            {
                //printf("I contain %d :", i);
                //lines[j].Print();

                newPrize = lines[j].prize + GetMinP(lines[j].start);
                if(newPrize <= minp[i-1])
                {
                    minp[i] = newPrize;
                    findLine = true;
                    break;                      // minp[j] = minp[j-1] - tova ne moje da bade podobreno
                }
            }

        if(!findLine)
        {
           // printf("lalalalalaaaaaaaaaaaaaaaa %d\n", i);
            minp[i] = minp[i-1] + 1;
            //printf("minp %d \b")
        }
    }

    printf("%d\n", minp[B]);
    /*
    for(int i = A; i <= B; i++)
    {
        printf("%d :  %d\n", i, minp[i]);
    }
    */
    return 0;
}
