#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

struct track {
    int s, f, pr;
};

const int MAXN = 10006, MAXVAL = 2000000000;
      int n, narr, start, finish, S;
      int arr[MAXN * 2];
      int dp[1000006];
      int maxV;

bool used[1000006];
track a[MAXN];

vector <int> v;

void scan () {
    scanf ("%d %d %d", &n, &start, &finish);
    for (int i = 1; i <= n; ++i) {
        scanf ("%d %d %d", &a[i].s, &a[i].f, &a[i].pr);
        if (a[i].f < a[i].s) swap (a[i].f, a[i].s);
        if (a[i].f > maxV) maxV = a[i].f;
        used[a[i].s] = 1;
        used[a[i].f] = 1;
    }
}

void solve () {
    used[start] = 1;
    used[finish] = 1;
    if (finish > maxV) maxV = finish;
    for (int i = 1; i <= maxV; ++ i)
        if (used[i] == 1) arr[++narr] = i;
    for (int i = 1; i <= narr; ++ i)
        if (arr[i] == start) {
            S = i;
            break;
        }

    char k ;

    for (int i = S + 1; i <= narr; ++ i) {
        dp[arr[i]] = MAXVAL;
        if (arr[i] - arr[i - 1] + dp[arr[i-1]] < dp[arr[i]])
            dp[arr[i]] = arr[i] - arr[i - 1] + dp[arr[i-1]];
        for (int j = 1; j <= n; ++ j)
            if (arr[i] <= a[j].f && arr[i] >= a[j].s && a[j].pr + dp[a[j].s] < dp[arr[i]])
                dp[arr[i]] = a[j].pr + dp[a[j].s];
        if (arr[i] == finish) break;
    }

    cout << dp[finish] << endl;
}

int main () {
    // scrap ! -.-

    scan ();
    solve ();

    return 0;
}
