#include<iostream>
using namespace std;

#define D_RIGHT 0
#define D_LEFT 1

struct p
 {
     int x, h;
 }ps[15001];

int n, k;

int det(p a, p b, p c) {
    return a.x*(b.h-c.h) + b.x*(c.h-a.h) + c.x*(a.h-b.h);
}

bool visible(int t1, int t2) { //check if t1 sees t2
    if(t1>t2) swap(t1,t2);
    int i;
    for(i=t1+1; i<t2; i++) {
        if(det(ps[t1],ps[t2],ps[i])>=0) return false;
    }
    return true;
}

int farthestVisible(int tower, bool dir) {
    int i, farthest=tower, dist=0;
    if(dir==D_RIGHT) {
        i=tower+1;
        while(ps[i].x<=ps[tower].x+k && i<n) {
            if(ps[i].x-ps[tower].x>dist && visible(tower,i)) { farthest=i; dist=ps[i].x-ps[tower].x; }
            i++;
        }
    }
    else if(dir==D_LEFT) {
        i=tower-1;
        while(ps[i].x>=ps[tower].x-k && i>=0) {
            if(ps[tower].x-ps[i].x>dist && visible(i,tower)) { farthest=i; dist=ps[tower].x-ps[i].x; }
            i--;
        }
    }
    return farthest;
}

int main() {
    cin>>n>>k;
    int i; int hi, hm=0;
    for(i=0; i<n; i++) { cin>>ps[i].x>>ps[i].h; if(ps[i].h>hm) { hm=ps[i].h; hi=i; } }
    int tower=hi;
    int countR=0, countL=0;
    while(tower<n-1) {
        tower = farthestVisible(tower,D_RIGHT);
        countR++;
    }
    tower=hi;
    while(tower>0) {
        tower = farthestVisible(tower,D_LEFT);
        countL++;
    }
    cout<<countL+countR+1<<endl;
}

/*

8 9
1 3
2 7
5 8
6 2
9 10
12 20
13 18
15 16

*/
