#include <cstdio>
#include <vector>
#include <iostream>
#define MAXK 1000001
#define MAXN 10001
#define pb push_back
#define mp make_pair

using namespace std;

vector < pair<int, int> > g[MAXK];

struct data { int op, cl, price; char type; } m[MAXN];
int dp[MAXK], dp1[MAXK];
int beg, end;
int n;

bool us[MAXK];

void slow() {
    int i, j, k, opt1;
    dp1[beg] = 0;

    for(i=beg + 1; i<=end; i++)
    {
    opt1 = i - beg;
    for(j=0; j<g[i].size(); j++)
    for(k=g[i][j].first; k<i; k++)
    opt1 = min(opt1, dp1[k] + g[i][j].second);

    for(k=beg; k<i; k++)
    opt1 = min(opt1, dp1[k] + i - k);

    dp1[i] = opt1;
    }
    printf("%d\n", dp1[end]);
}

void fast() {
    int i, j, u, opt;

    for(j=0; j<n; j++)
    if(m[j].op <= beg && m[j].cl > beg) m[j].type = 'o';

    dp[beg] = 0, u = beg;
    for(i=beg + 1; i<=end; i++)
    {
    if(i != end && !us[i]) continue;

    opt = dp[u] + i - u;
    for(j=0; j<n && m[j].op < i; j++)
    {
    if(m[j].type == 'o') opt = min(opt, dp[m[j].op] + m[j].price);
    if(m[j].type == 'c' && m[j].op == i) m[j].type = 'o';
    if(m[j].type == 'o' && m[j].cl == i) m[j].type = 'c', u = i;
    }

    dp[i] = opt;
    }

    printf("%d\n", dp[end]);
    }

bool cmp(data a, data b) { return a.op < b.op; }

int main() {
    int i, j;

    scanf("%d%d%d", &n, &beg, &end);
    for(i=0; i<n; i++) {
    scanf("%d%d%d", &m[i].op, &m[i].cl, &m[i].price);
    m[i].cl = min(m[i].cl, end), m[i].op = max(m[i].op, beg);

    g[m[i].cl].pb(mp(m[i].op, m[i].price));
    m[i].type = 'c';
    us[m[i].op] = us[m[i].cl] = 1;
    }

    sort(m, m+n, cmp);

    if(end - beg + 1 <= 2000) slow();
    else fast();

    return 0;
}
