/*
TASK: expression
LANG: C++
*/

#include <cstdio>
#include <cstring>

int N, K;
bool cache[88];
unsigned long long f[88];

unsigned long long go ( int x ) {
	
	if ( x ==N ) return 1;
	
	unsigned long long &ref = f[x];
	if ( cache[x] ) return ref;
	cache[x] = true;
	ref = 0;
	
	for ( int i=2; i<=K; ++i ) {
		if ( x + i <= N ) ref += go ( x + i );
		if ( x * i <= N && x ) ref += go ( x * i );
		}
	
	return ref;
	
}

int main (void) {
	
	scanf ( "%d%d", &N, &K );
	printf ( "%llu\n", go ( 0 ) );
	/*
	for ( int n=2; n<80; ++n )
		for ( int k=2; k<=n; ++k ) {
			memset ( cache, 0, sizeof cache );
			memset ( f, 0, sizeof f );
			N = n, K = k;
			printf ( "%d %d = %llu\n", n, k, go ( 0 ) );
			}
	*/
}
