#include <cstdio>
#define MAXN (1 << 5)
using namespace std;

typedef long long ll;

ll x;
ll a[MAXN];
int n;

inline int can(ll time) {
	ll ans = 0LL;
	for (int i=0; i < n; ++i) {
		ans += time / a[i];
	}
	return ans >= x;
}

inline void solve() {
	ll l = 1, r = 500000000000000000LL, mid;
	
	while (r-l > 1) {
		mid = (l+r) / 2LL;
		if (can(mid)) r = mid;
		else l = mid;
	}
	printf("%lld\n", r);
}

inline void read() {
	scanf("%lld%d", &x, &n);
	for (int i=0; i < n; ++i)
		scanf("%d", &a[i]);
}

int main() {
    read();
	solve();
    return 0;
}
