#include <cstdio>
#include <cstring>
#define MAXN (1 << 14)
using namespace std;

int n, k;
int h[MAXN], x[MAXN];
int dp[MAXN];

inline int legal(int a, int b, int c) {
	return ( (x[b]-x[a])*(h[c]-h[b]) - (x[c]-x[b])*(h[b]-h[a]) ) > 0;
}

inline void solve() {
	int sol = 0;
	memset(dp, -1, sizeof(dp));
	
	dp[0] = 1;
	for (int i=0; i < n; ++i) if (dp[i] > 0) {
		int j = i+1;
		int best = -1;
		while (j < n && x[j] <= x[i]+k) {
			//printf("%d %d %d\n", best, i, j);
			if (best == -1 || legal(i, best, j)) {
				best = j;
				if (dp[j] == -1 || dp[j] > dp[i]+1) {
					dp[j] = dp[i] + 1;
				}
			}
			j++;
		}
	}
	
	printf("%d\n", dp[n-1]);
}

inline void read() {
	scanf("%d%d", &n, &k);
	for (int i=0; i < n; ++i) {
		scanf("%d%d", &x[i], &h[i]);
	}
}

int main() {
	read();
	solve();
	return 0;
}
